Package org.zkoss.zk.ui.sys

## Interface PageConfig

-     public interface PageConfig

  Represents the info used to initialize a page.
  Since:
    3.0.0
  Author:
    tomyeh
  See Also:
    `PageCtrl.init(org.zkoss.zk.ui.sys.PageConfig)`

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `java.lang.String` | `getAfterHeadTags()` | Returns the content that shall be generated inside the head element and after ZK's default tags (never null).
    `java.lang.String` | `getBeforeHeadTags()` | Returns the content that shall be generated inside the head element and before ZK's default tags (never null).
    `java.lang.String` | `getId()` | Returns the page identifier, or null if auto-generation is required.
    `java.util.Collection<java.lang.Object[]>` | `getResponseHeaders()` | Returns a readonly collection of response headers (never null).
    `java.lang.String` | `getStyle()` | Returns the page's CSS style, or null if no special CSS style to assign.
    `java.lang.String` | `getTitle()` | Returns the page title, or null if not available (no title at all).
    `java.lang.String` | `getUuid()` | Returns the page's UUID.
    `java.lang.String` | `getViewport()` | Return the page's viewport, or "auto" if not specified.

- - ### Method Detail

    - #### getId

          java.lang.String getId()

      Returns the page identifier, or null if auto-generation is required. It is the identifier set by the application developer. If null, the implementation of `PageCtrl.init(org.zkoss.zk.ui.sys.PageConfig)` shall generate one automatically.

      Note: if `Page.setId(java.lang.String)` was called with a non-empty value before, this method is ignored.

    - #### getUuid

          java.lang.String getUuid()

      Returns the page's UUID. This method is used only in the recovering mode (`ExecutionCtrl.isRecovering()`). In other words, it is null if not in the recovering mode.

    - #### getTitle

          java.lang.String getTitle()

      Returns the page title, or null if not available (no title at all).

      Note: if `Page.setTitle(java.lang.String)` was called with a non-empty value before, this method is ignored.

    - #### getStyle

          java.lang.String getStyle()

      Returns the page's CSS style, or null if no special CSS style to assign.

      Note: if `Page.setStyle(java.lang.String)` was called with a non-empty value before, this method is ignored.

    - #### getViewport

          java.lang.String getViewport()

      Return the page's viewport, or "auto" if not specified.

      Note: if `Page.setViewport(java.lang.String)` was called with a non-empty value before, this method is ignored.

      Since:
        6.5.0

    - #### getBeforeHeadTags

          java.lang.String getBeforeHeadTags()

      Returns the content that shall be generated inside the head element and before ZK's default tags (never null). For example, it might consist of <meta> and <link>.

      Since it is generated before ZK's default tags (such as CSS and JS), it cannot override ZK's default behaviors.

      Since:
        5.0.5
      See Also:
        `getAfterHeadTags()`

    - #### getAfterHeadTags

          java.lang.String getAfterHeadTags()

      Returns the content that shall be generated inside the head element and after ZK's default tags (never null). For example, it might consist of <meta> and <link>.

      Since it is generated after ZK's default tags (such as CSS and JS), it could override ZK's default behaviors.

      Since:
        5.0.5
      See Also:
        `getBeforeHeadTags()`

    - #### getResponseHeaders

          java.util.Collection<java.lang.Object[]> getResponseHeaders()

      Returns a readonly collection of response headers (never null). Each item is a three-element object array. The first element is the header name. The second element of the array is the value which is an instance of `Date` or `String` (and never null). The third element indicates whether to add (rather than set) header. It is an instance of Boolean (and never null).
      Since:
        5.0.2